﻿using Infragistics.Controls.Editors;
using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGPopupOnCellCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
        }

        private void XamDataGrid_CellActivated(object sender, Infragistics.Windows.DataPresenter.Events.CellActivatedEventArgs e)
        {
            Cell c = e.Cell;
            if (c.Field.Name.Contains("LastNote"))
            {
                CellValuePresenter CVP = CellValuePresenter.FromCell(c);
                thePopup.PlacementTarget = CVP;
                thePopup.IsOpen = true;

                Dispatcher.BeginInvoke(new Action(() =>
                {
                    XamTextEditor XTE = thePopup.Child as XamTextEditor;
                    XTE.StartEditMode();
                }));
            }
        }

        private void TextEditor1_LostFocus(object sender, RoutedEventArgs e)
        {
            thePopup.IsOpen = false;                       
        }

        private void TextEditor1_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                XamTextEditor XTE = sender as XamTextEditor;
                               
                var x = XTE.Text.ToArray();
                int index = XTE.SelectionStart;

                string str = null;
                for (int i = 0; i < XTE.SelectionStart; i++)
                {
                    str += x[i];
                }

                str = str + Environment.NewLine;

                for (int i = XTE.SelectionStart; i < XTE.Text.Length; i++)
                {
                    str += x[i];
                }

                XTE.Text = str;

                XTE.SelectionStart = index + 2;

                e.Handled = true;
            }
        }
    }
}
